  Lorsque ssh forwarde X11, il utilise le programme xauth pour
enregistrer le nouveau DISPLAY  utiliser.
  Lors de multiples connexions simultanes par ssh avec forwarding de
X11 sur des machines avec le mme compte $HOME (partag par NFS par
exemple), les "xauth" sont fait en parallles et essaye d'accder tous
en mme temps au fichier $HOME/.Xauthority.

  Pour rsoudre ce problme, en attendant que xauth soit corrig, il
existe deux solutions :

-1- srialiser les appels  ssh

-2- utiliser un fichier Xauthority diffrent pour chaque connection
ssh, ce qui vite les problmes d'accs concurrent.



Solution 1 (Alexandre DENIS)
----------

-- positionner LEO_RSH  "ssh -f" ('-f' demande  ssh de forker ds
que la connexion est tablie)
-- lancer l'application avec "leonie -w" ('-w' demande  leonie
d'attendre que le lanceur forke quand il est prt).

L'impact sur la vitesse de lancement n'est pas flagrant.




Solution 2 (Vincent DANJEAN)
----------

  Pour cela :
rajouter le script ${HOME}/.ssh/rc contenant :
----------------------------------------------------
#!/bin/sh

if [ -n "$SSH_AUTH_SOCK" ]; then
        DIRNAME="$(dirname $SSH_AUTH_SOCK)"
	export XAUTHORITY="$DIRNAME/Xauthority"
	mkdir -p `dirname "$DIRNAME"`
fi
#echo XAUTHORITY=$XAUTHORITY
if read proto cookie && [ -n "$DISPLAY" ]; then
	if [ -n "$XAUTHORITY" -a ! -f "$XAUTHORITY" ] ; then
		touch "$XAUTHORITY"
	fi
	if [ `echo $DISPLAY | cut -c1-10` = 'localhost:' ]; then
		# X11UseLocalhost=yes
		echo add unix:`echo $DISPLAY |
		cut -c11-` $proto $cookie
	else
		# X11UseLocalhost=no
		echo add $DISPLAY $proto $cookie
	fi | xauth -q -
fi
----------------------------------------------------

Puis, si vous utilisez bash:
****************************
Rajoutez dans ${HOME}/.bashrc (et ${HOME}/.bash_profile s'il n'inclut pas
${HOME}/.bashrc) :
----------------------------------------------------
if [ -n "$SSH_AUTH_SOCK" ]; then
	DIRNAME="$(dirname $SSH_AUTH_SOCK)"
	if [ -f "$DIRNAME/Xauthority" ]; then
		export XAUTHORITY="$DIRNAME/Xauthority"
	fi
fi
----------------------------------------------------

Si vous utilisez [t]csh:
****************************
Rajoutez dans ${HOME}/.cshrc (ou ${HOME}/.tcshrc si ncessaire)
----------------------------------------------------
if ( $?SSH_AUTH_SOCK ) then
	DIRNAME="`dirname $SSH_AUTH_SOCK`"
	if ( -f "$DIRNAME/Xauthority" ) then
		setenv XAUTHORITY "$DIRNAME/Xauthority"
	endif
endif




